using UnityEngine;

namespace Mod
{
  public class Mod
  {
    public static void Main()
    {
      CategoryBuilder.Create("MVD", "More Russians MVD!", ModAPI.LoadSprite("mvd.jpg"));

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Soldier 1",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/omonicon.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONSoldier1.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Soldier 2",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/omon4ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONSoldier2.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Soldier 3",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/omon4ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONSoldier3.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Camo Soldier 1",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/fomon1ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONForestSoldier1.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Camo Soldier 2",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/fomonic2.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONForestSoldier2.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Camo Soldier 3",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/fomon3ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONForestSoldier3.png"),
          };
        }
      }
      );
      ModAPI.Register(
      new Modification()
      {

        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[O] OMON Camo Soldier 4",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/fomon4ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("OMON/OMONForestSoldier4.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Kolpak-1",
        NameToOrderByOverride = "!",
        DescriptionOverride = "Legendary helmet",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kolpakic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Kolpac1.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] SH-94",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/ssh942ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/SSH-94.png", 6f); //file and scale
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Camo SH-94",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/ssh941ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/SSH-942.png", 6f); //file and scale
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "[O] OMON Cap",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/cap1ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/cap.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "[O] Ushanka",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/ushic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/ushanka.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "[O] OMON Camo Cap",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/cap2ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/cap2.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Kora-Vo (1)",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kora1ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Kora-Vo1.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 30f;
          armor.armorPiece = "UpperBody";
          armor.armorTier = 55;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Kora-Vo (2)",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kora2ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Kora-Vo2.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 30f;
          armor.armorPiece = "MiddleBody";
          armor.armorTier = 55;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Kora-Vo 2 (1)",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kora3ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Kora-Vo3.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 40f;
          armor.armorPiece = "UpperBody";
          armor.armorTier = 60;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Kora-Vo 2 (2)",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kora4ic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Kora-Vo4.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 40f;
          armor.armorPiece = "MiddleBody";
          armor.armorTier = 60;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] OMON Beret",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/Beretic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Beret.png", 5f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Riot Right Shoulder Pad",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/shoulderic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/ShoulderPads1.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

          armor.stabResistance = 20f;
          armor.armorPiece = "UpperArmFront";
          armor.armorTier = 20;

          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[O] Riot Left Shoulder Pad",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/sloulderic2.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/ShoulderPads2.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

          armor.stabResistance = 20f;
          armor.armorPiece = "UpperArm";
          armor.armorTier = 20;

          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Insulator"),
        NameOverride = "[O] Backpack",
        NameToOrderByOverride = "!",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/bpic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("OMON/Backpack.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

          armor.stabResistance = 15f;
          armor.armorPiece = "MiddleBody";
          armor.armorTier = 0;

          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
          Instance.FixColliders();
        }
      }
      );

    }





    public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
      public Texture2D[] Textures = new Texture2D[0];
      public PersonBehaviour person;
      public int CurrentTexture = -2;
      public int Scale = 3;

      void Start()
      {
        SetTexture();
      }

      public void SetTexture()
      {
        if (Textures.Length == 0)
        return;

        if(CurrentTexture == -2)
        {
          CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
        }
        person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
        for (int i = 0; i < person.Limbs.Length; i++)
        {
          person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();

        }
      }
      }    }
    }
